// EnvTest.cpp
// This file is public domain software (PDS).

#include <windows.h>
#include <stdio.h>

typedef  BOOL (__stdcall *REGENERATEUSERENVIRONMENT)(LPVOID *lpEnvironment, BOOL bUpdate);

// shell32!RegenerateUserEnvironment
REGENERATEUSERENVIRONMENT pRegenerateUserEnvironment = NULL;

void PrintEnvironmentW(LPVOID lpEnvironment)
{
    printf("lpEnvironment: %p\n", lpEnvironment);
    LPWSTR pch = (LPWSTR)lpEnvironment;
    while (*pch)
    {
        printf("%ls\n", pch);
        pch += lstrlenW(pch) + 1;
    }
}

void PrintEnvironmentA()
{
    LPVOID lpEnvironment = GetEnvironmentStrings();
    printf("lpEnvironment: %p\n", lpEnvironment);
    {
        LPSTR pch = (LPSTR)lpEnvironment;
        while (*pch)
        {
            printf("%s\n", pch);
            pch += lstrlenA(pch) + 1;
        }
    }
    FreeEnvironmentStrings((LPTSTR)lpEnvironment);
}

int main(void)
{
    // get RegenerateUserEnvironment
    HINSTANCE hShell32 = LoadLibrary(TEXT("shell32.dll"));
    pRegenerateUserEnvironment = (REGENERATEUSERENVIRONMENT)GetProcAddress(hShell32, "RegenerateUserEnvironment");

    if (pRegenerateUserEnvironment == NULL)
    {
        printf("pRegenerateUserEnvironment is null\n");
        return 1;
    }

    printf("--------------------------------------------\n");
    printf("#1\n");
    printf("--------------------------------------------\n");
    PrintEnvironmentA();

    printf("--------------------------------------------\n");
    printf("#2\n");
    printf("--------------------------------------------\n");
    PrintEnvironmentA();

    LPVOID lpEnvironment;
    {
        (*pRegenerateUserEnvironment)(&lpEnvironment, TRUE);
    }

    printf("--------------------------------------------\n");
    printf("#3\n");
    printf("--------------------------------------------\n");
    PrintEnvironmentA();

    printf("--------------------------------------------\n");
    printf("#4\n");
    printf("--------------------------------------------\n");
    PrintEnvironmentW(lpEnvironment);

    FreeEnvironmentStrings((LPTSTR)lpEnvironment);
    {
        (*pRegenerateUserEnvironment)(&lpEnvironment, TRUE);
    }

    printf("--------------------------------------------\n");
    printf("#5\n");
    printf("--------------------------------------------\n");
    PrintEnvironmentW(lpEnvironment);

    FreeLibrary(hShell32);
    return 0;
}
